/**
 * Load an XML file into a new window
 */
function xml_load()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterXUL);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
	{
  		var file = fp.file;
		var url="file://"+file.path;
		window.open(url);
	}
}

/**
 * Save an XML file to the local machine
 */
function xml_save()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save As", nsIFilePicker.modeSave);
	fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterXUL);
	var res = fp.show();
	
	if(res == fp.returnCancel)
		return;
	
	if ( res == nsIFilePicker.returnOK )
        var f = fp.file
	
	
	// create a file and outputstream instance
    var fs = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream )

    try {
	    	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
			var documentLength = documentList.length;
			for(var i = 0; i < documentLength; i++)
   			{
    			pageDocument = documentList[i];
		        //fs.init( f, 0x02 | 0x08 | 0x20, 420, 0 );
		        fs.init(f, 0x02 | 0x08, 0664, null);
		        var serializer = new XMLSerializer()
		        serializer.serializeToStream( pageDocument, fs, 'UTF-8' )
		        fs.close()
   			}
    } catch (e) {
        //statusbar.postErrorMessage(e)
        alert(postErrorMessage(e));
    } finally {
        fs.close()
    }
}	

function xml_close()
{
	window.close();	
}

function xml_save_editor()
{
	var txt=document.getElementById('testeditor').contentWindow.document.body.innerHTML;
	//alert('<?xml version="1.0" ?>'+escape(txt));
	//alert(txt);
	//alert(escape(txt));
	var parser = new DOMParser();
	var newDoc = parser.parseFromString(escape(txt), "text/xml");
	//xml_save();
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save As", nsIFilePicker.modeSave);
	
	var res = fp.show();
	
	if(res == fp.returnCancel)
		return;
	
	if ( res == nsIFilePicker.returnOK )
        var f = fp.file
	
	
	// create a file and outputstream instance
    var fs = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream )

    try {
	        fs.init(f, 0x02 | 0x08, 0664, null);
	        var serializer = new XMLSerializer();
	        serializer.serializeToStream( newDoc, fs, 'UTF-8' );
	        fs.close()
   			
    } catch (e) {
        //statusbar.postErrorMessage(e)
        alert(postErrorMessage(e));
    } finally {
        fs.close()
    }	
}

function xml_open_editor()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterXUL);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
	{
  		var file = fp.file;
		var url="file://"+file.path;
		var hold = document.getElementById('testeditor').parentNode;
		hold.removeChild(document.getElementById('testeditor'));
		
		var editor=document.createElement("editor");
		editor.setAttribute("src",url);
		editor.setAttribute("id","testeditor");
		editor.setAttribute("flex","1");
		
		document.getElementsByTagName("window")[0].appendChild(editor);
		
	}
}


function xml_init_editor()
{
	//document.getElementById('testeditor').makeEditable('html',false);
	//document.getElementById('testeditor').setAttribute("src","http://www.google.com");
	//document.getElementById('testeditor').contentWindow.document.body.innerHTML='<?xml version=\"1.0\" ?>';
}