/**
 * Load an XML file into a new window
 */
function xml_load()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterXUL);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
	{
  		var file = fp.file;
		var url="file://"+file.path;
		window.open(url);
	}
}

/**
 * Save an XML file to the local machine
 */
function xml_save()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save As", nsIFilePicker.modeSave);
	fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterXUL);
	var res = fp.show();
	
	if(res == fp.returnCancel)
		return;
	
	if ( res == nsIFilePicker.returnOK )
        var f = fp.file
	
	
	// create a file and outputstream instance
    var fs = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream )

    try {
        fs.init( f, 0x04 | 0x08 | 0x20, 420, 0 );
        var serializer = new XMLSerializer()
        serializer.serializeToStream( xml, fs, 'UTF-8' )
        fs.close()
    } catch (e) {
        //statusbar.postErrorMessage(e)
        alert(postErrorMessage(e));
    } finally {
        fs.close()
    }
}	

function xml_close()
{
	window.close();	
}