/**
 * stats.js
 * @author Scott Root
 * Functionality for the stats section of the toolbar
 */

var myWin= null;
var documentList;
var documentLength;
var words="";
var nodes="";

/**
 * xml_stats_construct()
 * acts as a kind of constructor
 */
function xml_stats_construct()
{
	documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	documentLength = documentList.length;
}

/**
 * xml_node_count
 * Counts the number of nodes from a given input string
 * @param none
 * @return void
 */
function xml_node_count()
{
	xml_stats_construct();
	var nodeToCount = window.prompt("Enter the node you wish to count: ","Node");
	if(nodeToCount != null)
	{
		alert("There are "+nodeCount(nodeToCount)+" nodes named "+nodeToCount+".");
	}
}


/**
 * Searches a document to find n occurences of a specified node
 * @param string node to find
 * @return void
 */
function nodeCount(str)
{
	//Could also use XPath, but why bother with the overhead.
	var num_nodes=0;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
		var nodes=pageDocument.getElementsByTagName(str);
		num_nodes+=nodes.length;
		
	}
	return num_nodes;
}


/**
 * @author Scott Root
 * Reports all the nodes in the doc and # of occurrences
 */
function xml_node_count_all()
{
	xml_stats_construct();
	var nodeArr = new Array();
	var output="", nodeCount=0, colorNum=0;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
		nodes=xml_traverse(pageDocument,1);
		nodes=nodes.match(/\b\w+\b/g);
		nodes=nodes.toString();
		nodeArr=nodes.split(",");
		nodeArr=nodeArr.sort();
		for(var j=0; j<nodeArr.length; j++) 
		{
			nodeCount=1;
			for(var k=0; k<nodeArr.length; k++) 
			{
				if((nodeArr[j].toLowerCase() == nodeArr[k].toLowerCase()) && (j != k))
				{
					nodeCount++;
				}	
			}
			colorNum % 2 == 0 ? color="#c0c0ff" : color="#ffffff"
			output+="<tr style=\"background-color:"+color+"\"><td>"+nodeArr[j]+"</td><td>"+nodeCount+"</td></tr>";
			j+=(nodeCount-1);
			colorNum++;
		}
	}
		myWindow = window.open("", "tinyWindow", 'width=300,height=400');
		myWindow.document.write("Your report is as follows: <br/>In alphabetical order...");
		myWindow.document.write("<div style=\"background-color:white;overflow:auto;height:300;\" >");
		myWindow.document.write("<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" ><tr><th>Node</th><th>Count</th></tr>");
		myWindow.document.write(output);
		myWindow.document.write("</table>");
		myWindow.document.write("</div><p onmouseover=\"this.style.cursor='pointer';\" onclick=\"window.close();\"><u>Close [x]</u></p>");
		myWindow.document.bgColor="lightblue";
		myWindow.document.close();
}


function xml_word_count()
{
	words="";
	var wordToCount = window.prompt("Enter the word you wish to count: ","Word");
	if(wordToCount != null)
	{
		alert("There are "+myWordCount(wordToCount)+" words named "+wordToCount+".");
	}
}

function myWordCount(word)
{
	xml_stats_construct();
	var myArr = new Array();
	var count=0;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	words=xml_traverse(pageDocument,3);
    	var w_a = words.match(/\b\w+\b/g);
		var tmp = w_a.toString();
		myArr=tmp.split(',');
		myArr = myArr.sort();
    	for(var j=0; j<myArr.length; j++) 
    	{
    		if(word.toLowerCase() == myArr[j].toLowerCase())
    		{
    			count ++;
    		}
    	}
	}
	return count;
}

/**
 * @author Scott Root
 * @param node : starting point in the tree to begin traversing DOM-like
 * @param type : CONSTANT Integer to determine what type of node we are looking for (1=element, 3=textNode)
 * Traverses the "DOM" to get * based on the parameters
 */
function xml_traverse(node,type) 
{
	if(node.nodeType == type && type == 1)
	{
		if(node.nodeName != "undefined" && node.nodeName != "" && node.nodeName != null )
		{
			words += node.nodeName +",";
		}
	}
	if(node.nodeType == type && type == 3) 
	{
		words += node.nodeValue;
	}
	if(node.childNodes != null) 
	{
		for ( var i = 0; i < node.childNodes.length; i++) 
		{
			xml_traverse(node.childNodes.item(i),type);
		}
	}
	return words;
}

//****************************

function xml_word_count_all()
{
	xml_stats_construct();
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
		var co = xml_countWords(pageDocument);
	}
}

//*******************************
function xml_countWords(src) 
{
	var myArr = new Array();
	var wc = 0, words = "", exists=false, count=0, wordCount=0, output="";
	xml_traverse(src);
	var w_a = words.match(/\b\w+\b/g);
	var tmp = w_a.toString();
	myArr=tmp.split(',');
	myArr=myArr.sort();
	if (w_a != null) 
	{
		wc = w_a.length;
	}
	
	for(var j=0; j<myArr.length; j++) 
	{
		var theWord = myArr[j].toUpperCase();
		exists=false;
		
		var ct= ckTheWord(theWord);
		if(ct != 0 && exists == false)
		{
			//inc count of word
			wordCount % 2 == 0 ? color="#c0c0ff" : color="#ffffff"
			output+="<tr style=\"background-color:"+color+"\"><td>"+theWord+"</td><td>"+ct+"</td></tr>";
		}
		else
		{
			//output += "PROBLEMO!";
		}
		j=(j+(ct-1));
		wordCount++;
	}
	myWindow = window.open("", "tinyWindow", 'width=300,height=400');
		myWindow.document.write("Your report is as follows: <br/>In alphabetical order...");
		myWindow.document.write("<div style=\"background-color:white;overflow:auto;height:300;\" >");
		myWindow.document.write("<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" ><tr><th>Word</th<th>Count</th></tr>");
		myWindow.document.write(output);
		myWindow.document.write("</table>");
		myWindow.document.write("</div><p onmouseover=\"this.style.cursor='pointer';\" onclick=\"window.close();\"><u>Close [x]</u></p>");
		myWindow.document.bgColor="lightblue";
		myWindow.document.close();


	
	/**
	 * How many times a word appears in the doc (Array)
	 * @param theWord : Word to be checked
	 */
	function ckTheWord(theWord)
	{
		theWord=theWord.toString();
		var counter = 0;
		for(var k=0; k<myArr.length; k++) 
		{
			//If the word is match and hasn't been checked already, increment counter
			if(theWord.toLowerCase() == myArr[k].toLowerCase())
			{
				counter ++;
			}
		}
		return counter;
	}
	
	function xml_traverse(node) 
	{
		if (node.nodeType == 3) 
		{
			myArr[count]=node.nodeValue; count++;
			words += node.nodeValue; words = words.toString(); words = words.toUpperCase();
		}
		if (node.childNodes != null) 
		{
			for ( var i = 0; i < node.childNodes.length; i++) 
			{
				xml_traverse(node.childNodes.item(i));
			}
		}
	}

return wc;
}


//***************************************************

/**
 * Kick off load test
 */
function xml_speed_stats()
{
	window.open("http://www.websiteoptimization.com/services/analyze/wso.php?url="+window.content.location.href);
}
 
 
 
 
 
 
 
 
 