/**
 * @author Scott Root
 * styles2.js
 * Handles the CSS manipulation
 */

/**
 * @author Scott Root
 * Adds a user-defined style sheet to a given XML doc
 */
function xml_add_css()
{
	var cssFile = xml_getFile("css");
	var filename=cssFile.file;
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	//alert(filename.path);
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];		
    	//alert(pageDocument.firstChild.nodeName);
 	
		var InfoLayer_CSS = pageDocument.createElementNS('http://www.w3.org/1999/xhtml', 'link');
		InfoLayer_CSS.setAttribute('rel', 'stylesheet');
		InfoLayer_CSS.setAttribute('href', filename.path);
		InfoLayer_CSS.setAttribute('type', 'text/css');
    }
    
	pageDocument.documentElement.appendChild(InfoLayer_CSS);
}
 
/**
 * @author Scott Root
 * Opens a new page with a frame to view the externally linked CSS
 * If embedded style tags and declarations are in the document, then it wont.
 */ 
function xml_view_css()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var linkTags;
	//alert(filename.path);
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	if(pageDocument.styleSheets)
		{
			ss=pageDocument.styleSheets;
			for(var j=0; j<ss.length; j++) 
			{	
				if(ss[j].href == window.content.location.href)
				{
					alert("This stylesheet is embedded which you can view with view-source.");	
				}
				else
				{
					var n=window.open("","XMLDeveloper - View CSS");
					n.document.write('<frameset cols=20%,80%>');
					n.document.write('<frame src="'+ss[j].href+'" name="f1">');
					n.document.write('<frame src="'+window.content.location.href+'" name="f2">');
					n.document.write('</frameset>');
					n.document.close();
				}
			}
		}
    }
}

/**
 * @author Scott Root
 * Disables all of the CSS for the given document
 */
function xml_disable_css()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var linkTags;
	
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	if(pageDocument.styleSheets)
		{
			for(var j=0; j<pageDocument.styleSheets.length; j++) 
			{
					pageDocument.styleSheets[j].disabled=true;	
			}	
		}	
    }    
}

/**
 * @author Scott Root
 * Removes a given CSS rule based on selector text given from the user
 */
function xml_remove_rule()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var userIn =  window.prompt("Enter the selector text of the rule you want removed: ","Style removal");
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	if(pageDocument.styleSheets)
		{
			for(var k=0; k<pageDocument.styleSheets.length; k++) 
			{
				var mysheet=pageDocument.styleSheets[k];
				for (j=0; j<mysheet.cssRules.length; j++)
				{
					if (mysheet.cssRules[j].selectorText==userIn)
					{
						mysheet.deleteRule(j);
					}
				}
			}
		}
    }
}

function xml_insert_rule()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var userIn =  window.prompt("Enter a CSS rule (may need to add display:block; for it to show: ","Insert Rule");
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
		pageDocument.styleSheets[0].insertRule(userIn, 0);
    }
}
