<?xml version="1.0"?>
  <xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:myNS="http://devedge.netscape.com/2002/de">
      
      <xsl:output method="html" />
      
      <xsl:template match="/">
          <html>
              
              <head>
                  
                  <title>
                      <xsl:value-of select="/myNS:Article/myNS:Title"/>
                  </title>
                  
                  <style type="text/css">
                      .myBox {margin:10px 155px 0 50px; border: 1px dotted #639ACE; padding:0 5px 0 5px;}
                  </style>
                  
              </head>
              
              <body>
                  <p class="myBox">
                      <span class="title">
                          <xsl:value-of select="/myNS:Article/myNS:Title"/>
                      </span> <br />
                      
                      Authors:   <br />
                      <xsl:apply-templates select="/myNS:Article/myNS:Authors/myNS:Author"/>
                  </p>
                  
                  <p class="myBox">
                      <xsl:apply-templates select="//myNS:Body"/>
                  </p>
                  
              </body>
              
          </html>
      </xsl:template>
      
      <xsl:template match="myNS:Author">
           <xsl:value-of select="." />
          
          <xsl:if test="@company">
             <b>  <xsl:value-of select="@company" />  </b>
          </xsl:if>
          
          <br />
      </xsl:template>
      
      <xsl:template match="myNS:Body">
          <xsl:copy>
              <xsl:apply-templates select="@*|node()"/>
          </xsl:copy>
      </xsl:template>
      
      <xsl:template match="@*|node()">
          <xsl:copy>
              <xsl:apply-templates select="@*|node()"/>
          </xsl:copy>
      </xsl:template>
  </xsl:stylesheet> 