/**
 * @author Scott Root
 * transformations.js
 * Handles all transformation operations
 */


function xml_local_xslt()
{
	var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker); 
	    //picker.appendFilters(picker.filterXML | picker.filterXSL);
	    picker.defaultExtension = ".xsl";
	    picker.init(window, "Select File", picker.modeOpen);
	    var rv = picker.show();
	    if (rv == picker.returnCanel)
	      return;
	
	    //use the io service to conver the file to a uri
	    var ioSvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	    var uri = ioSvc.newFileURI(picker.file);
	    xslUrl = uri.spec;
	    
	//function getSend(url,param,ret){
   try{   
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      // Replace query with test location:
      url = "http://www.w3schools.com/xsl/cdcatalog.xsl";
      req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
      //var req = new XMLHttpRequest();
      req.overrideMimeType("text/xml");
      req.onerror = function (e) {
         alert("error "+e);
         //clearTimeout(this.tm);
         ret.xmlResponse(false);
      }
      
      req.onload = function () {
         //clearTimeout(this.tm);
         ret.xmlResponse(this.responseXML);
         alert("connected");
      }
      req.timeout = function(){
         //clearTimeout(this.tm);
         ret.xmlResponse(false);
      }
      req.open("GET", url, true);
      // Should insert some error handling for when the send timeouts.
      req.send("");
      //req.tm = setTimeout("req.timeout();",20000);
      //alert("connect");
   }catch(e){
      alert(e);
   }

}




/**
 * @author Scott Root
 * Will handle the processing of XSL files
 * @param type: local or remote
 */
function xml_XSLT_init(type)
{
	//netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	//netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");
	var xslStylesheet;
	var xsltProcessor = new XSLTProcessor();
	var myDOM;
	var xmlDoc, xslUrl, tmpDoc;
	var currentURL=window.content.location.href;  //Current Location (hopefully a .xml file...
	
	if(type =="local")
	{
	
		var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker); 
	    //picker.appendFilters(picker.filterXML | picker.filterXSL);
	    picker.defaultExtension = ".xsl";
	    picker.init(window, "Select File", picker.modeOpen);
	    var rv = picker.show();
	    if (rv == picker.returnCanel)
	      return;
	
	    //use the io service to conver the file to a uri
	    var ioSvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	    var uri = ioSvc.newFileURI(picker.file);
	    xslUrl = uri.spec;
	  
		var data = "";
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		                        .createInstance(Components.interfaces.nsIFileInputStream);
		var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		                        .createInstance(Components.interfaces.nsIScriptableInputStream);
		fstream.init(picker.file, -1, 0, 0);
		sstream.init(fstream); 
		
		var str = sstream.read(4096);
		while (str.length > 0) {
		  data += str;
		  str = sstream.read(4096);
		}
		
		sstream.close();
		fstream.close();
		//alert(data);
		tmpDoc=document.open("text/xml");
		tmpDoc.document.write(data);
		tmpDoc.document.close();
	}
	else
	{
		//Location of XSL document
		xslUrl = window.prompt("Enter the URL of the XSL file: ","http://"); 	
	}    
	  
	   	//request the xsl document
	   	var myXMLHTTPRequest = new XMLHttpRequest();
	   	if (myXMLHTTPRequest.overrideMimeType) {
			myXMLHTTPRequest.overrideMimeType('text/xml');
		}
	   	myXMLHTTPRequest.open("GET", xslUrl, false);
	   	myXMLHTTPRequest.send(null); 
	   	
	   	xslStylesheet = myXMLHTTPRequest.responseXML;
	   	//alert(xslStylesheet.firstChild.nodeName + " :: " +xslStylesheet.firstChild.nodeValue);
		xsltProcessor.importStylesheet(xslStylesheet);
		//xsltProcessor.importStylesheet(tmpDoc);
		
		// load the xml file
		myXMLHTTPRequest = new XMLHttpRequest();
		if (myXMLHTTPRequest.overrideMimeType) {
			myXMLHTTPRequest.overrideMimeType('text/xml');
		}
		myXMLHTTPRequest.open("GET", currentURL, false);
		myXMLHTTPRequest.send(null);
		
		xmlDoc = myXMLHTTPRequest.responseXML;
		
		var fragment = xsltProcessor.transformToFragment(xmlDoc, document);
		var newDocument = xsltProcessor.transformToDocument(xmlDoc);
	
	  	myDOM = fragment;
		
		var newWin = window.open('','Your transformed document -- XMLDeveloper');
		newWin.document.getElementsByTagName("title")[0].appendChild(newWin.document.createTextNode("Your transformed document -- XMLDeveloper"));
		newWin.document.getElementsByTagName("body")[0].appendChild(fragment);
	

}

/**
 * @author Scott Root
 * The goal here is to be able to view linked or applied XSLT
 * Is this possible since the document.styleSheets method does not look for XSL?!
 */
 
function xml_XSLT_view()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var pi;
	var piType;
	var isSheet=false;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];		
    	
    	for(var j=0; j<pageDocument.childNodes.length; j++) 
    	{
    		
    	}
    		/*
	    	if(pageDocument.childNodes[j].nodeName == "xml-stylesheet" )
	    	{
	    		isSheet=true;
	    		//Processing instruction
	    		pi=pageDocument.childNodes[j]; 
				alert(pi);
				
			
					//piType=pageDocument.childNodes[j].getAttribute('type');
					piType=pi.getAttribute("type");
					alert(piType);
					if(piType == "text/xsl")
					{
						var href=pageDocument.childNodes[j].getAttributes().getNamedItem("href").getNodeValue();
						window.open(href.nodeValue);
					}		
	    	}
    	}
    	if(isSheet == false)
    	{
    		alert("There appears to not be any XSL associated with this document.");
    	}
    	**/ 
    	
    }	
}



/*var xslFile = xml_getFile("xslt");
		var filename=xslFile.file;
		alert(filename);
		var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
		var documentLength = documentList.length;
		
		for(var i = 0; i < documentLength; i++)
	    {
	    	pageDocument = documentList[i];		
	    	//alert(pageDocument.firstChild.nodeName);
	 	
			var InfoLayer_XSL = pageDocument.createElementNS('http://www.w3.org/1999/xhtml', 'link');
			InfoLayer_XSL.setAttribute('rel', 'stylesheet');
			InfoLayer_XSL.setAttribute('href', filename.path);
			InfoLayer_XSL.setAttribute('type', 'text/xsl');
	    }
    
		pageDocument.documentElement.appendChild(InfoLayer_XSL);
		*/
		
/*var xslUrl = window.prompt("Enter the URL of the XSL file: ","http://"); //Location of XSL document
		
		// load the xslt file, example1.xsl
		var myXMLHTTPRequest = new XMLHttpRequest();
		if (myXMLHTTPRequest.overrideMimeType) {
			myXMLHTTPRequest.overrideMimeType('text/xml');
		}
		//myXMLHTTPRequest.open("GET", "http://www.w3schools.com/xsl/cdcatalog.xsl", false);
		myXMLHTTPRequest.open("GET",xslUrl , false);
		myXMLHTTPRequest.send(null);
		
		xslStylesheet = myXMLHTTPRequest.responseXML;
		xsltProcessor.importStylesheet(xslStylesheet);
		
		// load the xml file, example1.xml
		myXMLHTTPRequest = new XMLHttpRequest();
		myXMLHTTPRequest.open("GET", currentURL, false);
		myXMLHTTPRequest.send(null);
		
		xmlDoc = myXMLHTTPRequest.responseXML;
		
		var fragment = xsltProcessor.transformToFragment(xmlDoc, document);
		var newDocument = xsltProcessor.transformToDocument(xmlDoc);
	
	  	myDOM = fragment;
	
		var newWin = window.open('','Your transformed document -- XMLDeveloper');
		newWin.document.getElementsByTagName("title")[0].appendChild(newWin.document.createTextNode("Your transformed document -- XMLDeveloper"));
		newWin.document.getElementsByTagName("body")[0].appendChild(fragment);
		*/