/**
 * This page handles all of the validation tools
 * Inspired by: XSD Schema Validator 1.0.0, by Tihomir Surdilovic,
 * This is a tool extension that validates W3C XML schema documents. It uses the XSV REC (20010502) tool developed by Henry S. Thompson and Richard Tobin of the Language Technology Group of the Human Communication Research Centre in the Division of Informatics at the University of Edinburgh.
 * @author Scott Root
 * 
 */

function xml_open_val() {
    openXSDXUL("validation.xul");
}

function openXSDXUL(xulFile){
   try{
     // window.openDialog('chrome://xmldeveloper/content/' + xulFile, 'ExtensionListOptions', 'centerscreen, chrome, resizable').focus();
      window.open('chrome://xmldeveloper/content/validation/' + xulFile, 'ExtensionListOptions', 'centerscreen, chrome, resizable');
   }catch(e){
      alert("Error opening window: " + xulFile + " " + e);
   }
}

function xml_well_formed()
{
	openXSDXUL("xsd_val.xul");	
}